<template>
  <single-panel
    v-if="order"
    :capt="order.orderNumber"
    :backlink="{ name: 'order__performerer' }"
  >
    <div class="order-tracking">
      <div class="order-tracking__main">
        <header class="header">
          <div class="header__left">
            <h1>
              Заказ {{ order.orderNumber}}
            </h1>
            <span class="status status--executed">
              {{ statusesMap[order.status] }}
            </span>
          </div>
          <div class="header__right">
            <div class='order-card-body__header-text'>
              <span>Начало трекинга:</span>
              <span class="date">{{ order.trackingStartDt | date('DD.MM.YYYY') }}</span>
              <span v-if="!!order.trackingStartDt">{{ order.trackingStartDt | date('HH:mm') }}</span>
            </div>
            <div class='order-card-body__header-text'>
              <span>Окончание трекинга:</span>
              <span class="date">{{ order.trackingEndDt | date('DD.MM.YYYY') }}</span>
              <span v-if="!!order.trackingEndDt">{{ order.trackingEndDt | date('HH:mm') }}</span>
            </div>
            <div class='order-card-body__header-text'>
              <span>ПВП:</span>
              <span class="date">{{ order.loadingDt | date('DD.MM.YYYY') }}</span>
              <span>{{ order.loadingDt | date('HH:mm') }}</span>
            </div>
          </div>
        </header>

        <nav class="order-tracking__nav">
          <ob-tabs
            v-model="activeTab"
            :items="tabsItems"
            :no-border="true"
          />
          <ul>
            <li>
              <ObMenuDropdown :items="dropdownMenu" />
            </li>
          </ul>
        </nav>

        <div class="order-tracking__content">
          <transition name="fadeIn" mode="out-in">
            <keep-alive>
              <component
                :style="{ transitionDuration: '0.1s' }"
                :is="activeComponent"
                :uuid="$route.params.id"
              />
            </keep-alive>
          </transition>
        </div>
      </div>

      <aside class="sidebar">
        <order-logist-info
          :client="{role: order.clientRole, title: order.clientName}"
          :clientContact="{firstname: order.contactUserName, lastname: order.contactUserlastName, email: order.contactUserEmail}"
          :contractor="{role: order.executorRole, title: order.executorName}"
          :logist="{firstname: order.logistName, lastname: order.logistLastName, email: order.logistEmail}"
        />

        <div class="ob-order__status">
          <div class="order-total">
            <span class="external-number__title">Внешний номер заказа</span>
            <p>
              <span class="external-number__value">{{ order.externalNumber || '-' }}</span>
            </p>
          </div>
        </div>

        <div class="ob-order__status" v-if="order.status === 'PROCESSED'">
          <p class="ob-order__status-ended">
            Трекинг завершён
          </p>
        </div>

        <div class="ob-order__status" v-if="order.status === 'NEW'">
          <p class="ob-order__status-ended">
            Ожидание начала трекинга
          </p>
        </div>

<!--        <div class="ob-order__status">-->
<!--          <div class="prime-cost">-->
<!--            <h3>Стоимость</h3>-->
<!--            <p :class="['prime-cost__title', isCostExpanded ? 'prime-cost__title&#45;&#45;expanded' : '']" @click="isCostExpanded = !isCostExpanded">-->
<!--              <span>-->
<!--                <i class="icon chevron-down"></i>-->
<!--                Услуги трекинга-->
<!--              </span>-->
<!--              <strong>{{ new Intl.NumberFormat('ru-RU').format(Math.round(order.totalPrice / 100)) }} ₽</strong>-->
<!--            </p>-->
<!--            <expand-transition-->
<!--            -->
<!--            >-->
<!--              <div v-if="isCostExpanded">-->
<!--                <p v-for = 'service in order.services' :key="service.serviceUuid">-->
<!--                  {{ service.title }}-->
<!--                  <span>{{ new Intl.NumberFormat('ru-RU').format(Math.round(service.price / 100)) }}</span>-->
<!--                </p> -->
<!--              </div>-->
<!--            </expand-transition>-->
<!--          </div>-->
<!--        </div>-->

<!--        <div class="ob-order__status">-->
<!--          <div class="order-total">-->
<!--            <p>-->
<!--              <span>Предварительно<br />к оплате</span>-->
<!--              <span>{{ new Intl.NumberFormat('ru-RU').format(Math.round(order.totalPrice / 100)) }} ₽</span>-->
<!--            </p>-->
<!--            <p v-if="order.vat && order.vat > 0">-->
<!--              <span>В том числе НДС</span>-->
<!--              <span>{{ new Intl.NumberFormat('ru-RU').format(Math.round(order.vat / 100)) }} ₽</span>-->
<!--            </p>-->
<!--            <p v-else>НДС не облагается</p>-->
<!--          </div>-->
<!--        </div>-->
      </aside>
    </div>

    <ob-modal
        ref="cancelOrderModal"
        title="Отмена заказа"
        size="medium"
        :is-show-controls="true"
        ok-text="Отменить"
        cancel-text="Нет, не отменять"
        @submit="cancelOrder2"
    >
      <p>
        Данный заказ будет отменен, все внесенные данные будут удалены. Вы действительно хотите отменить заказ?
      </p>
    </ob-modal>

    <ob-modal
        ref="publicLinkModal"
        title="Публичная ссылка на карту"
        size="medium"
        :is-show-controls="false"
    >
      <p>
        <strong>{{ publickLinkUrl }}</strong>
      </p>
      <p>
        {{ copyPublicLinkResult}}
      </p>
      <p>
        <ob-button
            label="Закрыть"
            data-qa="btnClosePublicLinkModal"
            @click="closePublicLinkModal"
        />
      </p>
    </ob-modal>
  </single-panel>
</template>

<script>
  import api from '@/api';
  import state, { setState } from './state/tracking';
  import singlePanel from 'common-components/src/obComponents/obSinglePanels';
  import datePicker from 'common-components/src/obComponents/obDatePickerConstructor';
  import ObTabs from 'common-components/src/obComponents/obTabs';
  import ObMenuDropdown from 'common-components/src/obComponents/obMenuDropdown';
  import ObModal from "common-components/src/obComponents/obModal";
  import obButton from 'common-components/src/obComponents/obButton';
  import OrderTrackingExecution from '../../components/Order/orderTracking/execution';
  import OrderTrackingmap from '../../components/Order/orderTracking/map';
  import orderLogistInfo from '../../components/Order/orderLogistInfo';
  import expandTransition from 'common-components/src/obComponents/obExpandTransition';
  import {copyToClipboard} from 'common-components/src/utils/clipboard'

  export default {
    name: 'ordertrackingItem',

    components: {
      singlePanel,
      datePicker,
      ObTabs,
      ObMenuDropdown,
      ObModal,
      obButton,
      OrderTrackingExecution,
      OrderTrackingmap,
      orderLogistInfo,
      expandTransition,
    },

    async created() {
      this.setStateOrder(null);
      let notificationId = new Date().getTime() + "save";
      try {
        this.$notification({
          type: "system_notification_in_load",
          message: "Загрузка",
          id: notificationId
        });
        const order = await api.orders.getTrackingOrder(this.$route.params.id);
        
        if (order) {
          // this.order = { ...order };
          this.setStateOrder(order);
        }

      } catch (e) {
        this.$notification({
          type: "system_notification_error",
          message: "Не удалось загрузить"
        });
        console.error(e);
      } finally {
        this.$notification({ event: "close", id: notificationId });
      }
    },

    data() {
      return {
        // order: null,
        tabsItems: [
          {
            uuid: 'Исполнение',
            title: 'Исполнение'
          },
          {
            uuid: 'Карта',
            title: 'Карта'
          }
        ],
        activeTab: { uuid: 'Исполнение', title: 'Исполнение' },
        isCostExpanded: false,
        publicPageUuid: null,
        copyPublicLinkResult: '',
      }
    },

    computed: {
      activeComponent () {
        let componentsMap = {
          'Исполнение': OrderTrackingExecution,
          'Карта': OrderTrackingmap,
        };
        return componentsMap[this.activeTab.uuid]
      },

      order() {
        return state.order
      },

      statusesMap() {
        return state.statusesMap;
      },

      allowCancelOrder() {
        return ['NEW', 'IN_PROCESS'].includes(this.order.status);
      },

      dropdownMenu() {
        return [
          {
            title: 'Скопировать публичную ссылку на карту',
            method: this.copyPublicLink,
          },
          {
            title: 'Отменить заказ',
            isDisabled: !this.allowCancelOrder,
            method: this.cancelOrder,
          }
        ]
      },
      publickLinkUrl() {
        return `${location.origin}/unauthorized-tracking-map/${this.publicPageUuid}`;
      },
    },

    methods: {
      setStateOrder(data) {
        setState(data)
      },

      cancelOrder() {
        this.$refs.cancelOrderModal.open();
      },

      async cancelOrder2() {
        this.$refs.cancelOrderModal.close();
        try {
          await api.orders.trackingOrderAction(this.$route.params.id, 'CANCEL');
          this.$notification({
            type: "system_notification_success",
            message: "Запрос на отмену заказа создан",
          });
        } catch (error) {
          if (error.status === 400) {
            this.$notification({
              type: "system_notification_error",
              message: "Заказ исполнен или отменен",
            });
          } else {
            this.$notification({
              type: "system_notification_error",
              message: "Ошибка при отмене заказа",
            });
          }
        }
      },

      async copyPublicLink() {
        try {
          if (!this.publicPageUuid) {
            const { publicPageUuid } = await api.orders.getPublicLink(this.$route.params.id)
            this.publicPageUuid = publicPageUuid;
          }
          this.copyPublicLinkToBuffer();
          this.$refs.publicLinkModal.open();

        } catch (error) {
          if (error.status === 404) {
            this.$notification({
              type: "system_notification_error",
              message: "Заказ не найден",
            });
          } else {
            this.$notification({
              type: "system_notification_error",
              message: "Ошибка при получении публичной ссылки",
            });
          }
        }
      },

      copyPublicLinkToBuffer() {
        const successful = copyToClipboard(this.publickLinkUrl)
        if (successful) {
          this.copyPublicLinkResult = 'Ссылка скопирована в буфер обмена';
        } else {
          this.copyPublicLinkResult = 'Ссылка не может быть скопирована в буфер обмена';
        }
      },

      closePublicLinkModal() {
        this.$refs.publicLinkModal.close();
      },
    }
  }
</script>

<style lang="scss" scoped>
@import '~common-components/src/static/css/variables';
@import '~common-components/src/static/css/mixins';

.order-tracking {
  display: flex;
  height: 100%;
  position: relative;
}

.order-tracking__main {
  flex-grow: 1;
  overflow-y: hidden;
  display: flex;
  flex-direction: column;
}

.header {
  position: relative;
  z-index: 3;
  display: flex;
  justify-content: space-between;
  align-items: flex-start;
  padding: 21px 20px 5px;
  border-bottom: none;
  background: #fff;

  h1 {
    @include font-mixin(24px, 36px, 700, $style-black);

    sup {
      @include font-mixin(12px, 20px, 400, $gray-slate, 0.6, uppercase);
      opacity: 0.8;
    }
  }
}

.header__left {
  display: flex;
  flex-direction: column;
  align-items: flex-start;
}

.status {
  margin-top: 4px;
  padding: 10px;
  @include font-mixin(16px, 20px, 400, $color-text-base);

  &--executed {
    background:rgba(16, 207, 150, 0.1);
  }
}

.order-tracking__nav {
  position: relative;
  z-index: 2; 
  padding-left: 20px;
  padding-right: 20px;
  padding-top: 20px;
  display: flex;
  justify-content: space-between;
  width: 100%;
  @include font-mixin(16px, 20px, 400, $gray-slate, 0.4px);
  box-shadow: 0px 2px 8px rgba(0, 75, 200, 0.14);

  & > div {
    width: auto;
    flex-grow: 2;
  }

  ul {
    display: flex;
    align-items: center;
    flex-shrink: 0;
    list-style: none;
  }

  .active {
    color: $color-blue-navy-blue;
    border-color: $color-blue-navy-blue;
  }

  span {
    padding: 8px 10px;
  }
}

.order-tracking__content {
  flex-grow: 1;
  position: relative;
}

.sidebar {
  position: relative;
  flex: 0 0 316px;
  z-index: 2;
  width: 316px;
  box-shadow: 0px 4px 10px rgba(0, 75, 200, 0.06), 0px 0px 12px rgba(0, 75, 200, 0.04), 0px 0px 2px rgba(0, 75, 200, 0.15);
}

.ob-order__status {
  padding: 20px 30px 0;
}

.ob-order__status-ended {
  display: inline-flex;
  padding: 8px 10px;
  background-color: rgba($color-green-light, 0.4);
}

.ob-order__action {
  display: flex;
  justify-content: center;
}

.prime-cost {
  padding: 0 0 20px;
  border-bottom: 1px solid rgba(209, 210, 214, 0.5);

  h3 {
    margin-bottom: 17px;
  }

  p {
    display: flex;
    justify-content: space-between;
    font-size: 12px;
    color: $gray-slate;

    &:not(:last-child) {
      margin-bottom: 9px;
    }
  }
}

p.prime-cost__title {
  position: relative;
  color: $color-text-base;

  i {
    position: absolute;
    left: -18px;
  }

  &--expanded {
    i {
      transform: rotate(180deg);
    }
  }
}

.order-total {
  margin-left: -30px;
  margin-right: -30px;
  padding-bottom: 20px;
  padding-left: 30px;
  padding-right: 30px;
  border-bottom: 1px solid rgba(209, 210, 214, 0.5);

  p {
    display: flex;
    justify-content: space-between;
    @include font-mixin(12px, 14px, 400, $gray-slate);
  }

  p:first-child {
    margin-bottom: 10px;
    @include font-mixin(16px, 20px, 700, $topMenuTextHover);
  }
}

.fadeIn-leave-to {
  opacity: 0;
}

.fadeIn-enter-active, .fadeIn-leave-active {
  transition: opacity .4s linear;
}

.external-number {
  &__title {
    color: #737682;
    font-size: 10px;
  }

  &__value {
    color: #191E32;
    font-size: 14px;
  }
}

.order-card-body {
  position: absolute;
  overflow: hidden;
  z-index: 10;
  top: 60px;
  left: 0;
  display: flex;
  flex-direction: column;
  width: 100%;
  min-height: calc(100% - 74px);
  margin-bottom: 20px;
  background-color: $background-white;
  &__header-text {
    transition: transform .3s ease-in;
    @include font-mixin(12px, 20px, 400, $color-grey-span, 0.4px);
    transform: translateY(-2px);
    text-align: right;
    span {
      &.date {
        color: $color-text-base;
        & + span {
          margin-left: 4px;
        }
      }
      & + .date {
        margin-left: 8px;
      }
    }
  }

  &__header-text + &__header-text {
    margin-top: 6px;
  }

  &__header-right {
    display: flex;
    flex-direction: column;
  }
}
</style>

<style>
.order-tracking__container {
  padding: 32px 20px;
}
</style>